(*---------------------------------------------------------------------------*
  $Change$
  Copyright (c) 2006-2010, James H. Woodyatt
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  
    Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
    
    Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
  COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
  OF THE POSSIBILITY OF SUCH DAMAGE. 
 *---------------------------------------------------------------------------*)

(*
let jout = Cf_journal.stdout
*)

open Cf_cmonad.Op

class reader ~k ~fd ~limits pad = object
    inherit [Iom_stream.flowcontrol, Iom_stream.failed] Iom_reactor.reader
        ~k ~fd ~limits pad as super
    
    method private fragment =
        if more_ = Iom_stream.Last then Unix.close fd;
        super#fragment
end

class writer ~k ~fd pad = object
    inherit [Iom_octet_stream.fragment, Iom_stream.stop, Iom_stream.flownotify]
        Iom_reactor.writer ~k ~fd pad as super
    
    method private complete =
        Unix.close fd;
        super#complete
end

let create ~limits k =
    let fd0, fd1 = Unix.pipe () in
    Iom_stream.ifix (new reader ~k ~fd:fd0 ~limits) >>= fun ifix ->
    Iom_stream.ofix (new writer ~k ~fd:fd1) >>= fun ofix ->
    Cf_cmonad.return (ifix, ofix)

(*--- $File$ ---*)
